Index: /trunk/src/sys/arch/mips/mips/fp.S
===================================================================
--- /trunk/src/sys/arch/mips/mips/fp.S	(revision 151)
+++ /trunk/src/sys/arch/mips/mips/fp.S	(revision 152)
@@ -1,3 +1,3 @@
-/*	$NetBSD: fp.S,v 1.33.38.11 2010/05/11 20:54:27 matt Exp $	*/
+/*	$NetBSD: fp.S,v 1.33.38.13 2011/04/29 08:26:25 matt Exp $	*/
 
 /*
@@ -101,10 +101,10 @@
 /*----------------------------------------------------------------------------
  *
- * MachEmulateFP --
+ * mips_emul_fp --
  *
  *	Emulate unimplemented floating point operations.
- *	This routine should only be called by MachFPInterrupt().
- *
- *	MachEmulateFP(uint32_t instr, struct frame *frame, uint32_t cause)
+ *	This routine should only be called by mips_fpu_intr().
+ *
+ *	mips_emul_fp(uint32_t instr, struct trapframe *tf, uint32_t cause)
  *
  * Results:
@@ -127,5 +127,5 @@
 #endif
 #endif
-NESTED(MachEmulateFP, CALLFRAME_SIZ, ra)
+NESTED(mips_emul_fp, CALLFRAME_SIZ, ra)
 	PTR_SUBU sp, CALLFRAME_SIZ
 	REG_S	ra, CALLFRAME_RA(sp)
@@ -138,7 +138,7 @@
 	andi	v0, v0, 0x1F << PTR_SCALESHIFT	# mask FMT field
 #ifdef FPEMUL
-	PTR_L	t0, L_ADDR(MIPS_CURLWP)		# get pcb of current process
+	PTR_L	t0, L_PCB(MIPS_CURLWP)		# get pcb of current lwp
 	PTR_L	a3, fmt_tbl(v0)			# switch on FUNC & FMT
-	INT_L	a2, U_PCB_FPREGS+FRAME_FSR(t0)
+	INT_L	a2, PCB_FPREGS+FRAME_FSR(t0)
 #else
 	cfc1	a2, MIPS_FPU_CSR		# get exception register
@@ -648,9 +648,9 @@
 mfromc1:
 	srl	t1, a0, 11-FPX_SCALESHIFT	# fs is in bits 15:11
-	PTR_L	t0, L_ADDR(MIPS_CURLWP)		# get pcb of lwp
+	PTR_L	t0, L_PCB(MIPS_CURLWP)		# get pcb of current lwp
 	andi	t1, t1, FPX_REGMASK
 	PTR_ADDU t0, t0, t1
 
-	FPX_L	v0, U_PCB_FPREGS+FRAME_FP0(t0)
+	FPX_L	v0, PCB_FPREGS+FRAME_FP0(t0)
 
 	srl	t0, a0, 16-REG_SCALESHIFT
@@ -674,9 +674,9 @@
 
 	srl	t1, a0, 11-FPX_SCALESHIFT
-	PTR_L	t0, L_ADDR(MIPS_CURLWP)		# get pcb of current process
+	PTR_L	t0, L_PCB(MIPS_CURLWP)		# get pcb of current lwp
 	andi	t1, t1, FPX_REGMASK
 	PTR_ADDU t0, t0, t1
 
-	FPX_S	v0, U_PCB_FPREGS+FRAME_FP0(t0)
+	FPX_S	v0, PCB_FPREGS+FRAME_FP0(t0)
 
 	b	done
@@ -685,9 +685,9 @@
 dmfromc1:
 	srl	t1, a0, 11-DFPX_SCALESHIFT	# fs is in bits 15:11
-	PTR_L	t0, L_ADDR(MIPS_CURLWP)		# get pcb of current process
+	PTR_L	t0, L_PCB(MIPS_CURLWP)		# get pcb of current lwp
 	andi	t1, t1,  DFPX_REGMASK
 	PTR_ADDU t0, t0, t1
 
-	DFPX_L	v0, U_PCB_FPREGS+FRAME_FP0(t0)
+	DFPX_L	v0, PCB_FPREGS+FRAME_FP0(t0)
 
 	srl	t0, a0, 16-REG_SCALESHIFT
@@ -711,9 +711,9 @@
 
 	srl	t1, a0, 11-DFPX_SCALESHIFT
-	PTR_L	t0, L_ADDR(MIPS_CURLWP)		# get pcb of current process
+	PTR_L	t0, L_PCB(MIPS_CURLWP)		# get pcb of current lwp
 	andi	t1, t1, DFPX_REGMASK
 	PTR_ADDU t0, t0, t1
 
-	DFPX_S	v0, U_PCB_FPREGS+FRAME_FP0(t0)
+	DFPX_S	v0, PCB_FPREGS+FRAME_FP0(t0)
 
 	b	done
@@ -722,5 +722,5 @@
 cfromc1:
 	srl	t1, a0, 11
-	PTR_L	t0, L_ADDR(MIPS_CURLWP)		# get pcb of current process
+	PTR_L	t0, L_PCB(MIPS_CURLWP)		# get pcb of current lwp
 	andi	t1, t1, 0x001F
 	li	t2, 0x1F
@@ -728,5 +728,5 @@
 	bne	t1, t2, cfinvalid
 
-	INT_L	v0, U_PCB_FPREGS+FRAME_FSR(t0)
+	INT_L	v0, PCB_FPREGS+FRAME_FSR(t0)
 
 cfinvalid:
@@ -758,7 +758,7 @@
 	REG_L	v0, TF_REG_ZERO(v0)
 	REG_EPILOGUE
-	PTR_L	t0, L_ADDR(MIPS_CURLWP)		# get pcb of current process
+	PTR_L	t0, L_PCB(MIPS_CURLWP)		# get pcb of current lwp
 	#nop
-	INT_S	v0, U_PCB_FPREGS+FRAME_FSR(t0)
+	INT_S	v0, PCB_FPREGS+FRAME_FSR(t0)
 
 	b	done
@@ -845,5 +845,5 @@
 	REG_EPILOGUE
 	PTR_ADDU a0, 4
-	jal	_C_LABEL(fuiword)
+	jal	_C_LABEL(ufetch_uint32)
 
 	move	a0, v0
@@ -855,9 +855,9 @@
 	or	a2, a2, t0
 
-	/* Free MachEmulateFP call frame */
+	/* Free mips_emul_fp call frame */
 	REG_L	ra, CALLFRAME_RA(sp)
 	PTR_ADDU sp, CALLFRAME_SIZ
 
-	j	_C_LABEL(bcemul_delay_slot)
+	j	_C_LABEL(mips_emul_branchdelayslot)
 #endif
 
@@ -1315,7 +1315,7 @@
 	bne	v0, zero, fpe_trap
 #ifdef FPEMUL
-	PTR_L	t1, L_ADDR(MIPS_CURLWP)		# get pcb of current process
+	PTR_L	t1, L_PCB(MIPS_CURLWP)		# get pcb of current lwp
 	#nop
-	INT_S	a2, U_PCB_FPREGS+FRAME_FSR(t1)
+	INT_S	a2, PCB_FPREGS+FRAME_FSR(t1)
 #else
 	ctc1	a2, MIPS_FPU_CSR		# save exceptions
@@ -1395,7 +1395,7 @@
 	bne	v0, zero, fpe_trap
 #ifdef FPEMUL
-	PTR_L	t1, L_ADDR(MIPS_CURLWP)		# get pcb of current process
+	PTR_L	t1, L_PCB(MIPS_CURLWP)		# get pcb of current lwp
 	#nop
-	INT_S	a2, U_PCB_FPREGS+FRAME_FSR(t1)
+	INT_S	a2, PCB_FPREGS+FRAME_FSR(t1)
 #else
 	ctc1	a2, MIPS_FPU_CSR		# save exceptions
@@ -1828,4 +1828,6 @@
 	jal	_C_LABEL(renorm_fs_s)
 	move	t9, zero
+	sll	t3, t2, 32 - 3			# convert S fraction to D
+	srl	t2, t2, 3
 	b	norm_d
 2:
@@ -2033,7 +2035,7 @@
 	bne	v0, zero, fpe_trap
 #ifdef FPEMUL
-	PTR_L	v0, L_ADDR(MIPS_CURLWP)		# get pcb of current process
+	PTR_L	v0, L_PCB(MIPS_CURLWP)		# get pcb of current lwp
 	#nop
-	INT_S	a2, U_PCB_FPREGS+FRAME_FSR(v0)
+	INT_S	a2, PCB_FPREGS+FRAME_FSR(v0)
 #else
 	ctc1	a2, MIPS_FPU_CSR		# save exceptions
@@ -2145,7 +2147,7 @@
 2:
 #ifdef FPEMUL
-	PTR_L	v0, L_ADDR(MIPS_CURLWP)		# get pcb of current process
+	PTR_L	v0, L_PCB(MIPS_CURLWP)		# get pcb of current lwp
 	#nop
-	INT_S	a2, U_PCB_FPREGS+FRAME_FSR(v0)
+	INT_S	a2, PCB_FPREGS+FRAME_FSR(v0)
 #else
 	ctc1	a2, MIPS_FPU_CSR		# save condition bit
@@ -2168,7 +2170,7 @@
 1:
 #ifdef FPEMUL
-	PTR_L	v0, L_ADDR(MIPS_CURLWP)		# get pcb of current process
+	PTR_L	v0, L_PCB(MIPS_CURLWP)		# get pcb of current lwp
 	#nop
-	INT_S	a2, U_PCB_FPREGS+FRAME_FSR(v0)
+	INT_S	a2, PCB_FPREGS+FRAME_FSR(v0)
 #else
 	ctc1	a2, MIPS_FPU_CSR		# save condition bit
@@ -2309,7 +2311,7 @@
 	bne	v0, zero, fpe_trap
 #ifdef FPEMUL
-	PTR_L	v0, L_ADDR(MIPS_CURLWP)		# get pcb of current process
+	PTR_L	v0, L_PCB(MIPS_CURLWP)		# get pcb of current lwp
 	#nop
-	INT_S	a2, U_PCB_FPREGS+FRAME_FSR(v0)
+	INT_S	a2, PCB_FPREGS+FRAME_FSR(v0)
 #else
 	ctc1	a2, MIPS_FPU_CSR		# save exceptions
@@ -2432,7 +2434,7 @@
 	bne	v0, zero, fpe_trap
 #ifdef FPEMUL
-	PTR_L	v0, L_ADDR(MIPS_CURLWP)		# get pcb of current process
+	PTR_L	v0, L_PCB(MIPS_CURLWP)		# get pcb of current lwp
 	#nop
-	INT_S	a2, U_PCB_FPREGS+FRAME_FSR(v0)
+	INT_S	a2, PCB_FPREGS+FRAME_FSR(v0)
 #else
 	ctc1	a2, MIPS_FPU_CSR		# save exceptions
@@ -2591,7 +2593,7 @@
 	bne	v0, zero, fpe_trap
 #ifdef FPEMUL
-	PTR_L	v0, L_ADDR(MIPS_CURLWP)		# get pcb of current process
+	PTR_L	v0, L_PCB(MIPS_CURLWP)		# get pcb of current lwp
 	#nop
-	INT_S	a2, U_PCB_FPREGS+FRAME_FSR(v0)
+	INT_S	a2, PCB_FPREGS+FRAME_FSR(v0)
 #else
 	ctc1	a2, MIPS_FPU_CSR		# save exceptions
@@ -2738,7 +2740,7 @@
 	bne	v0, zero, fpe_trap
 #ifdef FPEMUL
-	PTR_L	v0, L_ADDR(MIPS_CURLWP)		# get pcb of current process
+	PTR_L	v0, L_PCB(MIPS_CURLWP)		# get pcb of current lwp
 	#nop
-	INT_S	a2, U_PCB_FPREGS+FRAME_FSR(v0)
+	INT_S	a2, PCB_FPREGS+FRAME_FSR(v0)
 #else
 	ctc1	a2, MIPS_FPU_CSR		# save exceptions
@@ -2755,7 +2757,7 @@
 	bne	v0, zero, fpe_trap
 #ifdef FPEMUL
-	PTR_L	v0, L_ADDR(MIPS_CURLWP)		# get pcb of current process
+	PTR_L	v0, L_PCB(MIPS_CURLWP)		# get pcb of current lwp
 	#nop
-	INT_S	a2, U_PCB_FPREGS+FRAME_FSR(v0)
+	INT_S	a2, PCB_FPREGS+FRAME_FSR(v0)
 #else
 	ctc1	a2, MIPS_FPU_CSR		# save exceptions
@@ -2776,7 +2778,7 @@
 	bne	v0, zero, fpe_trap
 #ifdef FPEMUL
-	PTR_L	v0, L_ADDR(MIPS_CURLWP)		# get pcb of current process
+	PTR_L	v0, L_PCB(MIPS_CURLWP)		# get pcb of current lwp
 	#nop
-	INT_S	a2, U_PCB_FPREGS+FRAME_FSR(v0)
+	INT_S	a2, PCB_FPREGS+FRAME_FSR(v0)
 #else
 	ctc1	a2, MIPS_FPU_CSR		# save exceptions
@@ -2798,7 +2800,7 @@
 	bne	v0, zero, fpe_trap
 #ifdef FPEMUL
-	PTR_L	v0, L_ADDR(MIPS_CURLWP)		# get pcb of current process
+	PTR_L	v0, L_PCB(MIPS_CURLWP)		# get pcb of current lwp
 	#nop
-	INT_S	a2, U_PCB_FPREGS+FRAME_FSR(v0)
+	INT_S	a2, PCB_FPREGS+FRAME_FSR(v0)
 #else
 	ctc1	a2, MIPS_FPU_CSR		# save exceptions
@@ -2816,7 +2818,7 @@
 fpe_trap:
 #ifdef FPEMUL
-	PTR_L	v0, L_ADDR(MIPS_CURLWP)		# get pcb of current process
+	PTR_L	v0, L_PCB(MIPS_CURLWP)		# get pcb of current lwp
 	#nop
-	INT_S	a2, U_PCB_FPREGS+FRAME_FSR(v0)
+	INT_S	a2, PCB_FPREGS+FRAME_FSR(v0)
 #else
 	/*
@@ -2824,21 +2826,15 @@
 	 */
 	REG_S	a2, CALLFRAME_SIZ + 3*SZREG(sp)
-#ifdef MULTIPROCESSOR
-	PTR_L	v0, L_CPU(MIPS_CURLWP)
+	jal	_C_LABEL(fpu_save)		# on RM5231
+
+	REG_L	a2, CALLFRAME_SIZ + 3*SZREG(sp)
+
+	PTR_L	v0, L_PCB(MIPS_CURLWP)		# get pcb of current lwp
 	#nop
-	PTR_L	a0, CPU_INFO_FPCURLWP(v0)
-#else
-	PTR_L	a0, CPUVAR(FPCURLWP)
+	INT_S	a2, PCB_FPREGS+FRAME_FSR(v0)
 #endif
-	jal	_C_LABEL(fpusave_lwp)		# on RM5231
-
-	REG_L	a2, CALLFRAME_SIZ + 3*SZREG(sp)
-
-	PTR_L	v0, L_ADDR(MIPS_CURLWP)		# get pcb of current process
-	#nop
-	INT_S	a2, U_PCB_FPREGS+FRAME_FSR(v0)
-#endif
-	REG_L	a1, CALLFRAME_SIZ + 1*SZREG(sp)	# frame
-	REG_L	a2, CALLFRAME_SIZ + 2*SZREG(sp)	# cause
+	move	a3, a2				# fpustat
+	REG_L	a1, CALLFRAME_FRAME(sp)		# frame
+	REG_L	a2, CALLFRAME_CAUSE(sp)		# cause
 	REG_L	ra, CALLFRAME_RA(sp)
 	PTR_ADDU sp, CALLFRAME_SIZ
@@ -2846,11 +2842,11 @@
 
 /*
- * Send an illegal instruction signal to the current process.
+ * Send an illegal instruction signal to the current lwp.
  */
 ill:
 #ifdef FPEMUL
-	PTR_L	v0, L_ADDR(MIPS_CURLWP)		# get pcb of current process
+	PTR_L	v0, L_PCB(MIPS_CURLWP)		# get pcb of current lwp
 	#nop
-	INT_S	a2, U_PCB_FPREGS+FRAME_FSR(v0)
+	INT_S	a2, PCB_FPREGS+FRAME_FSR(v0)
 #else
 	ctc1	a2, MIPS_FPU_CSR		# save exceptions
@@ -2901,5 +2897,5 @@
 						# 3rd arg is FP CSR
 	move	a3, zero			# 4th arg is FALSE
-	jal	_C_LABEL(MachEmulateBranch)	# compute PC after branch
+	jal	_C_LABEL(mips_emul_branch)	# compute PC after branch
 
 	REG_L	a1, CALLFRAME_FRAME(sp)
@@ -2919,5 +2915,5 @@
 	PTR_ADDU sp, CALLFRAME_SIZ
 	j	ra
-END(MachEmulateFP)
+END(mips_emul_fp)
 
 /*----------------------------------------------------------------------------
@@ -2925,5 +2921,5 @@
  *
  *	Read (integer) the FS register (bits 15-11).
- *	This is an internal routine used by MachEmulateFP only.
+ *	This is an internal routine used by mips_emul_fp only.
  *
  * Results:
@@ -2936,9 +2932,9 @@
 #ifdef FPEMUL
 	srl	t2, a0, 11 - FPX_SCALESHIFT
-	PTR_L	t0, L_ADDR(MIPS_CURLWP)		# get pcb of current process
+	PTR_L	t0, L_PCB(MIPS_CURLWP)		# get pcb of current lwp
 	andi	t2, t2, FPX_REGEVENMASK		# Even regs only
 	PTR_ADDU t0, t0, t2
 
-	lw	t2, U_PCB_FPREGS+FRAME_FP0(t0)
+	lw	t2, PCB_FPREGS+FRAME_FP0(t0)
 
 	srl	t0, t2, 31		# init the sign bit
@@ -3034,5 +3030,5 @@
  *	Read (single precision) the FT register (bits 20-16) and
  *	the FS register (bits 15-11) and break up into fields.
- *	This is an internal routine used by MachEmulateFP only.
+ *	This is an internal routine used by mips_emul_fp only.
  *
  * Results:
@@ -3049,9 +3045,9 @@
 #ifdef FPEMUL
 	srl	ta0, a0, 16 - FPX_SCALESHIFT
-	PTR_L	ta1, L_ADDR(MIPS_CURLWP)	# get pcb of current process
+	PTR_L	ta1, L_PCB(MIPS_CURLWP)		# get pcb of current lwp
 	andi	ta0, ta0, FPX_REGEVENMASK	# Even regs only
 	PTR_ADDU ta1, ta1, ta0
 
-	lw	ta0, U_PCB_FPREGS+FRAME_FP0(ta1)
+	lw	ta0, PCB_FPREGS+FRAME_FP0(ta1)
 
 	srl	ta1, ta0, 23			# get exponent
@@ -3154,5 +3150,5 @@
  *	Read (single precision) the FS register (bits 15-11) and
  *	break up into fields.
- *	This is an internal routine used by MachEmulateFP only.
+ *	This is an internal routine used by mips_emul_fp only.
  *
  * Results:
@@ -3166,9 +3162,9 @@
 #ifdef FPEMUL
 	srl	t0, a0, 11 - FPX_SCALESHIFT
-	PTR_L	t1, L_ADDR(MIPS_CURLWP)		# get pcb of current process
+	PTR_L	t1, L_PCB(MIPS_CURLWP)		# get pcb of current lwp
 	andi	t0, t0, FPX_REGEVENMASK		# Even regs only
 	PTR_ADDU t1, t1, t0
 
-	lw	t0, U_PCB_FPREGS+FRAME_FP0(t1)
+	lw	t0, PCB_FPREGS+FRAME_FP0(t1)
 
 	srl	t1, t0, 23			# get exponent
@@ -3272,5 +3268,5 @@
  *	Read (double precision) the FT register (bits 20-16) and
  *	the FS register (bits 15-11) and break up into fields.
- *	This is an internal routine used by MachEmulateFP only.
+ *	This is an internal routine used by mips_emul_fp only.
  *
  * Results:
@@ -3289,15 +3285,15 @@
 #ifdef FPEMUL
 	srl	ta3, a0, 16 - FPX_SCALESHIFT
-	PTR_L	ta0, L_ADDR(MIPS_CURLWP)	# get pcb of current process
+	PTR_L	ta0, L_PCB(MIPS_CURLWP)		# get pcb of current lwp
 	andi	ta3, ta3, FPX_REGEVENMASK	# Even regs only
 	PTR_ADDU ta0, ta3
 
 #if defined(__mips_n32) || defined(__mips_n64)
-	FPX_L	ta3, U_PCB_FPREGS+FRAME_FP0(ta0)
+	FPX_L	ta3, PCB_FPREGS+FRAME_FP0(ta0)
 	dsrl	ta0, ta3, 32
 	srl	ta3, ta3, 0
 #else
-	lw	ta3, U_PCB_FPREGS+FRAME_FP0(ta0)
-	lw	ta0, U_PCB_FPREGS+FRAME_FP0+SZFPREG(ta0)
+	lw	ta3, PCB_FPREGS+FRAME_FP0(ta0)
+	lw	ta0, PCB_FPREGS+FRAME_FP0+SZFPREG(ta0)
 #endif
 
@@ -3417,5 +3413,5 @@
  *	Read (double precision) the FS register (bits 15-11) and
  *	break up into fields.
- *	This is an internal routine used by MachEmulateFP only.
+ *	This is an internal routine used by mips_emul_fp only.
  *
  * Results:
@@ -3430,15 +3426,15 @@
 #ifdef FPEMUL
 	srl	t3, a0, 11 - FPX_SCALESHIFT
-	PTR_L	t0, L_ADDR(MIPS_CURLWP)		# get pcb of current process
+	PTR_L	t0, L_PCB(MIPS_CURLWP)		# get pcb of current lwp
 	andi	t3, t3, FPX_REGEVENMASK		# Even regs only
 	PTR_ADDU t0, t3
 
 #if defined(__mips_n32) || defined(__mips_n64)
-	FPX_L	t3, U_PCB_FPREGS+FRAME_FP0(t0)
+	FPX_L	t3, PCB_FPREGS+FRAME_FP0(t0)
 	dsrl	t0, t3, 32
 	srl	t3, t3, 0
 #else
-	lw	t3, U_PCB_FPREGS+FRAME_FP0(t0)
-	lw	t0, U_PCB_FPREGS+FRAME_FP0+SZFPREG(t0)
+	lw	t3, PCB_FPREGS+FRAME_FP0(t0)
+	lw	t0, PCB_FPREGS+FRAME_FP0+SZFPREG(t0)
 #endif
 
@@ -3559,5 +3555,5 @@
  *	Read (single precision) the FS register (bits 15-11) and
  *	the FT register (bits 20-16) and break up into fields.
- *	This is an internal routine used by MachEmulateFP only.
+ *	This is an internal routine used by mips_emul_fp only.
  *
  * Results:
@@ -3574,9 +3570,9 @@
 #ifdef FPEMUL
 	srl	t1, a0, 11 - FPX_SCALESHIFT
-	PTR_L	ta2, L_ADDR(MIPS_CURLWP)		# get pcb of current process
+	PTR_L	ta2, L_PCB(MIPS_CURLWP)		# get pcb of current lwp
 	andi	t1, t1, FPX_REGEVENMASK			# Even regs only
 	PTR_ADDU t0, ta2, t1
 
-	lw	t0, U_PCB_FPREGS+FRAME_FP0(t0)
+	lw	t0, PCB_FPREGS+FRAME_FP0(t0)
 
 	srl	t1, t0, 23			# get exponent
@@ -3589,5 +3585,5 @@
 	PTR_ADDU ta2, ta0
 
-	lw	ta0, U_PCB_FPREGS+FRAME_FP0(ta2)
+	lw	ta0, PCB_FPREGS+FRAME_FP0(ta2)
 
 	srl	ta1, ta0, 23			# get exponent
@@ -3761,5 +3757,5 @@
  *	Read (double precision) the FS register (bits 15-11) and
  *	the FT register (bits 20-16) and break up into fields.
- *	This is an internal routine used by MachEmulateFP only.
+ *	This is an internal routine used by mips_emul_fp only.
  *
  * Results:
@@ -3778,15 +3774,15 @@
 #ifdef FPEMUL
 	srl	t1, a0, 11-FPX_SCALESHIFT
-	PTR_L	ta2, L_ADDR(MIPS_CURLWP)		# get pcb of current process
+	PTR_L	ta2, L_PCB(MIPS_CURLWP)		# get pcb of current lwp
 	andi	t1, t1, FPX_REGEVENMASK			# Even regs only
 	PTR_ADDU t0, ta2, t1
 
 #if defined(__mips_n32) || defined(__mips_n64)
-	FPX_L	t3, U_PCB_FPREGS+FRAME_FP0(t0)
+	FPX_L	t3, PCB_FPREGS+FRAME_FP0(t0)
 	dsrl	t0, t3, 32
 	srl	t3, t3, 0
 #else
-	FPX_L	t3, U_PCB_FPREGS+FRAME_FP0(t0)
-	FPX_L	t0, U_PCB_FPREGS+FRAME_FP0+SZFPREG(t0)
+	FPX_L	t3, PCB_FPREGS+FRAME_FP0(t0)
+	FPX_L	t0, PCB_FPREGS+FRAME_FP0+SZFPREG(t0)
 #endif
 
@@ -3801,10 +3797,10 @@
 
 #if defined(__mips_n32) || defined(__mips_n64)
-	FPX_L	ta3, U_PCB_FPREGS+FRAME_FP0(ta2)
+	FPX_L	ta3, PCB_FPREGS+FRAME_FP0(ta2)
 	dsrl	ta0, ta3, 32
 	srl	ta3, ta3, 0
 #else
-	lw	ta3, U_PCB_FPREGS+FRAME_FP0(ta2)
-	lw	ta0, U_PCB_FPREGS+FRAME_FP0+SZFPREG(ta2)
+	lw	ta3, PCB_FPREGS+FRAME_FP0(ta2)
+	lw	ta0, PCB_FPREGS+FRAME_FP0+SZFPREG(ta2)
 #endif
 
@@ -4010,5 +4006,5 @@
  *
  *	Write (single precision) the FD register (bits 10-6).
- *	This is an internal routine used by MachEmulateFP only.
+ *	This is an internal routine used by mips_emul_fp only.
  *
  * Arguments:
@@ -4021,5 +4017,5 @@
  *
  *	Write (integer) the FD register (bits 10-6).
- *	This is an internal routine used by MachEmulateFP only.
+ *	This is an internal routine used by mips_emul_fp only.
  *
  * Arguments:
@@ -4037,9 +4033,9 @@
 #ifdef FPEMUL
 	srl	t1, a0, 6 - FPX_SCALESHIFT
-	PTR_L	t0, L_ADDR(MIPS_CURLWP)		# get pcb of current process
+	PTR_L	t0, L_PCB(MIPS_CURLWP)		# get pcb of current lwp
 	andi	t1, t1, FPX_REGEVENMASK		# Even regs only
 	PTR_ADDU t0, t0, t1
 
-	FPX_S	t2, U_PCB_FPREGS+FRAME_FP0(t0)
+	FPX_S	t2, PCB_FPREGS+FRAME_FP0(t0)
 	j	ra
 #else
@@ -4124,5 +4120,5 @@
  *
  *	Write (double precision) the FT register (bits 10-6).
- *	This is an internal routine used by MachEmulateFP only.
+ *	This is an internal routine used by mips_emul_fp only.
  *
  * Arguments:
@@ -4143,15 +4139,15 @@
 
 	srl	t1, a0, 6-FPX_SCALESHIFT
-	PTR_L	t2, L_ADDR(MIPS_CURLWP)		# get pcb of current process
-
+	PTR_L	t2, L_PCB(MIPS_CURLWP)		# get pcb of current lwp
 	andi	t1, t1, FPX_REGEVENMASK
 	PTR_ADDU t2, t2, t1
+
 #if defined(__mips_n32) || defined(__mips_n64)
 	dsll	t0, t0, 32
 	or	t0, t0, t3
-	FPX_S	t0, U_PCB_FPREGS+FRAME_FP0(t2)
+	FPX_S	t0, PCB_FPREGS+FRAME_FP0(t2)
 #else
-	FPX_S	t3, U_PCB_FPREGS+FRAME_FP0(t2)
-	FPX_S	t0, U_PCB_FPREGS+FRAME_FP0+4(t2)
+	FPX_S	t3, PCB_FPREGS+FRAME_FP0(t2)
+	FPX_S	t0, PCB_FPREGS+FRAME_FP0+4(t2)
 #endif
 	j	ra
